Unit Mouse;

INTERFACE
uses DOS;

Var reg : Registers;

Type

ObjMouse    = OBJECT
               Procedure Init;
               Procedure Show;
               Procedure Erase;
               Procedure GoToXY(X,Y    : Byte);
               Procedure Limite (xmin,xmax,ymin,ymax  :integer);
               Function  WhereX : Integer;
               Function  WhereY : Integer;
               Function  Click  : Integer;
               End;
Rmouse      = RECORD
              X  : Byte;
              Y  : Byte;
              B  : Byte;
              END;

Procedure  Mouse_State (Var T : Rmouse );

IMPLEMENTATION

Procedure OBjMouse.Init;
begin;
          ASM
          MOV AX,$0000;
          INT ($33);
          END;
end;
{-------------------------------}
Procedure OBjMouse.Show;
begin;
          ASM
          MOV Ax,$1;
          INT ($33);
          END;
end;
{-------------------------------}
Procedure ObjMouse.Erase;
begin;
          ASM
          MOV Ax,$2;
          INT ($33);
          END;
end;
{-------------------------------}
Procedure ObjMouse.GoToXY;
begin;
reg.ax:=4;
reg.dx:=y;
reg.cx:=x;
intr($33,registers(reg));
end;
{-------------------------------}
Procedure ObjMouse.Limite;
begin;
reg.ax:=8;
reg.dx:=(xmin*8);
reg.cx:=(ymin*8);
intr($33,registers(reg));
reg.ax:=7;
reg.dx:=(xmax*8);
reg.cx:=(ymax*8);
intr($33,registers(reg));
end;
{-------------------------------}
Function ObjMouse.WhereX;
var
psg    : longint;
begin;
reg.ax:=3;
intr($33,registers(reg));
psg:=reg.cx;
psg:=(psg div 8)+1;
WhereX:=psg;
end;
{-------------------------------}
function ObjMouse.WhereY;
var
psg    : longint;
begin;
reg.ax:=3;
intr($33,registers(reg));
psg:=reg.dx;
psg:=(psg div 8)+1;
WhereY:=psg;
end;
{-------------------------------}
function ObjMouse.Click;
begin;
reg.ax:=3;
intr($33,registers(reg));
Click:=reg.bx;
end;


{}

PROCEDURE Mouse_State;
VAR       Mouse : ObjMouse;
BEGIN;
T.X :=Mouse.WhereX;
T.Y :=Mouse.WhereY;
T.B :=Mouse.Click;
END;

END.

